# Electrons on a Sphere Problem.
# Alexander S. Bondarenko - Summer 1998
# COPS 2.0 - September 2000
# COPS 3.0 - November 2002
# COPS 3.1 - March 2004

param np > 0, integer;              # number of electrons
param pi := 4*atan(1);

# Set the starting point to a quasi-uniform distribution
# of electrons on a unit sphere

option randseed '861276191';
param theta {i in 1..np} := 2*pi*Uniform01();
param phi   {i in 1..np} :=   pi*Uniform01();

var x {i in 1..np} := cos(theta[i])*sin(phi[i]);   # x-coordinate
var y {i in 1..np} := sin(theta[i])*sin(phi[i]);   # y-coordinate
var z {i in 1..np} :=               cos(phi[i]);   # z-coordinate

minimize coulomb_potential:  
  sum {i in 1..np-1} sum {j in i+1..np} 
  1.0/sqrt( (x[i] - x[j])^2 + (y[i] - y[j])^2 + (z[i] - z[j])^2 );

subject to on_the_unit_ball {i in 1..np}:  x[i]^2 + y[i]^2 + z[i]^2 = 1;

