# Todd Munson
# COPS 3.1 - March 2004

#####  Initialization

param V, integer;       # number of vertices
param E, integer;       # number of elements
param TOL;		# minimum area

set VERTICES := {1..V};
set ELEMENTS := {1..E};
set COORDS   := {1..2};

param TRIS{ELEMENTS, 1..3} in VERTICES;	# triangular element descriptions

var x{VERTICES, COORDS};    # (x,y) coordinates of vertices

##### Minimize f/g subject to volume constraint

var norm{e in ELEMENTS} = sum{i in COORDS} 
  ((1*x[TRIS[e,2],i]-x[TRIS[e,1],i])^2 +
   (2*x[TRIS[e,3],i]-x[TRIS[e,2],i]-x[TRIS[e,1],i])^2 / 3);

var area{e in ELEMENTS} = 
     2*((x[TRIS[e,2],1]-x[TRIS[e,1],1])*
        (x[TRIS[e,3],2]-x[TRIS[e,1],2])-
        (x[TRIS[e,3],1]-x[TRIS[e,1],1])*
        (x[TRIS[e,2],2]-x[TRIS[e,1],2])) / sqrt(3);

minimize f: sum {e in ELEMENTS} norm[e] / (2*area[e]);

subject to feas {e in ELEMENTS}: area[e] >= TOL;

